//**********************************************************************`
//* This is an include file generated by Message Compiler.             *`
//*                                                                    *`
//* Copyright (c) Microsoft Corporation. All Rights Reserved.          *`
//**********************************************************************`
#pragma once
#include <wmistr.h>
#include <evntrace.h>
#include "evntprov.h"
//
//  Initial Defs
//
#if !defined(ETW_INLINE)
#define ETW_INLINE DECLSPEC_NOINLINE __inline
#endif

#if defined(__cplusplus)
extern "C" {
#endif

//
// Allow disabling of code generation
//
#ifndef MCGEN_DISABLE_PROVIDER_CODE_GENERATION
#if  !defined(McGenDebug)
#define McGenDebug(a,b)
#endif 


#if !defined(MCGEN_TRACE_CONTEXT_DEF)
#define MCGEN_TRACE_CONTEXT_DEF
typedef struct _MCGEN_TRACE_CONTEXT
{
    TRACEHANDLE            RegistrationHandle;
    TRACEHANDLE            Logger;
    ULONGLONG              MatchAnyKeyword;
    ULONGLONG              MatchAllKeyword;
    ULONG                  Flags;
    ULONG                  IsEnabled;
    UCHAR                  Level; 
    UCHAR                  Reserve;
    USHORT                 EnableBitsCount;
    PULONG                 EnableBitMask;
    const ULONGLONG*       EnableKeyWords;
    const UCHAR*           EnableLevel;
} MCGEN_TRACE_CONTEXT, *PMCGEN_TRACE_CONTEXT;
#endif

#if !defined(MCGEN_LEVEL_KEYWORD_ENABLED_DEF)
#define MCGEN_LEVEL_KEYWORD_ENABLED_DEF
FORCEINLINE
BOOLEAN
McGenLevelKeywordEnabled(
    _In_ PMCGEN_TRACE_CONTEXT EnableInfo,
    _In_ UCHAR Level,
    _In_ ULONGLONG Keyword
    )
{
    //
    // Check if the event Level is lower than the level at which
    // the channel is enabled.
    // If the event Level is 0 or the channel is enabled at level 0,
    // all levels are enabled.
    //

    if ((Level <= EnableInfo->Level) || // This also covers the case of Level == 0.
        (EnableInfo->Level == 0)) {

        //
        // Check if Keyword is enabled
        //

        if ((Keyword == (ULONGLONG)0) ||
            ((Keyword & EnableInfo->MatchAnyKeyword) &&
             ((Keyword & EnableInfo->MatchAllKeyword) == EnableInfo->MatchAllKeyword))) {
            return TRUE;
        }
    }

    return FALSE;

}
#endif

#if !defined(MCGEN_EVENT_ENABLED_DEF)
#define MCGEN_EVENT_ENABLED_DEF
FORCEINLINE
BOOLEAN
McGenEventEnabled(
    _In_ PMCGEN_TRACE_CONTEXT EnableInfo,
    _In_ PCEVENT_DESCRIPTOR EventDescriptor
    )
{

    return McGenLevelKeywordEnabled(EnableInfo, EventDescriptor->Level, EventDescriptor->Keyword);

}
#endif


//
// EnableCheckMacro
//
#ifndef MCGEN_ENABLE_CHECK
#define MCGEN_ENABLE_CHECK(Context, Descriptor) (Context.IsEnabled &&  McGenEventEnabled(&Context, &Descriptor))
#endif

#if !defined(MCGEN_CONTROL_CALLBACK)
#define MCGEN_CONTROL_CALLBACK

DECLSPEC_NOINLINE __inline
VOID
__stdcall
McGenControlCallbackV2(
    _In_ LPCGUID SourceId,
    _In_ ULONG ControlCode,
    _In_ UCHAR Level,
    _In_ ULONGLONG MatchAnyKeyword,
    _In_ ULONGLONG MatchAllKeyword,
    _In_opt_ PEVENT_FILTER_DESCRIPTOR FilterData,
    _Inout_opt_ PVOID CallbackContext
    )
/*++

Routine Description:

    This is the notification callback for Windows Vista and later.

Arguments:

    SourceId - The GUID that identifies the session that enabled the provider. 

    ControlCode - The parameter indicates whether the provider 
                  is being enabled or disabled.

    Level - The level at which the event is enabled.

    MatchAnyKeyword - The bitmask of keywords that the provider uses to 
                      determine the category of events that it writes.

    MatchAllKeyword - This bitmask additionally restricts the category 
                      of events that the provider writes. 

    FilterData - The provider-defined data.

    CallbackContext - The context of the callback that is defined when the provider 
                      called EtwRegister to register itself.

Remarks:

    ETW calls this function to notify provider of enable/disable

--*/
{
    PMCGEN_TRACE_CONTEXT Ctx = (PMCGEN_TRACE_CONTEXT)CallbackContext;
    ULONG Ix;
#ifndef MCGEN_PRIVATE_ENABLE_CALLBACK_V2
    UNREFERENCED_PARAMETER(SourceId);
    UNREFERENCED_PARAMETER(FilterData);
#endif

    if (Ctx == NULL) {
        return;
    }

    switch (ControlCode) {

        case EVENT_CONTROL_CODE_ENABLE_PROVIDER:
            Ctx->Level = Level;
            Ctx->MatchAnyKeyword = MatchAnyKeyword;
            Ctx->MatchAllKeyword = MatchAllKeyword;
            Ctx->IsEnabled = EVENT_CONTROL_CODE_ENABLE_PROVIDER;

            for (Ix = 0; Ix < Ctx->EnableBitsCount; Ix += 1) {
                if (McGenLevelKeywordEnabled(Ctx, Ctx->EnableLevel[Ix], Ctx->EnableKeyWords[Ix]) != FALSE) {
                    Ctx->EnableBitMask[Ix >> 5] |= (1 << (Ix % 32));
                } else {
                    Ctx->EnableBitMask[Ix >> 5] &= ~(1 << (Ix % 32));
                }
            }
            break;

        case EVENT_CONTROL_CODE_DISABLE_PROVIDER:
            Ctx->IsEnabled = EVENT_CONTROL_CODE_DISABLE_PROVIDER;
            Ctx->Level = 0;
            Ctx->MatchAnyKeyword = 0;
            Ctx->MatchAllKeyword = 0;
            if (Ctx->EnableBitsCount > 0) {
                RtlZeroMemory(Ctx->EnableBitMask, (((Ctx->EnableBitsCount - 1) / 32) + 1) * sizeof(ULONG));
            }
            break;
 
        default:
            break;
    }

#ifdef MCGEN_PRIVATE_ENABLE_CALLBACK_V2
    //
    // Call user defined callback
    //
    MCGEN_PRIVATE_ENABLE_CALLBACK_V2(
        SourceId,
        ControlCode,
        Level,
        MatchAnyKeyword,
        MatchAllKeyword,
        FilterData,
        CallbackContext
        );
#endif
   
    return;
}

#endif
#endif // MCGEN_DISABLE_PROVIDER_CODE_GENERATION
//+
// Provider Valve-SteamNetworkingSockets Event Count 9
//+
EXTERN_C __declspec(selectany) const GUID VALVE_STEAMNETWORKINGSOCKETS = {0xb77d8a36, 0xef0c, 0x4976, {0x8d, 0x22, 0x08, 0xf9, 0x86, 0xf5, 0x6c, 0xfb}};

//
// Opcodes
//
#define _LongOpOpcode 0xa
#define _SendOpcode 0xb
#define _SendToOpcode 0xc
#define _RecvOpcode 0xd
#define _ProcessOpcode 0xe
#define _SetSockOptOpcode 0xf

//
// Tasks
//
#define LongOp_Task 0x1
EXTERN_C __declspec(selectany) const GUID LongOpId = {0x255f5c19, 0xe0d4, 0x48bc, {0xa8, 0x80, 0x68, 0x06, 0x91, 0x8a, 0x2d, 0x01}};
#define UDP_Task 0x2
EXTERN_C __declspec(selectany) const GUID UDPId = {0x255f5c19, 0xe0d4, 0x48bc, {0xa8, 0x80, 0x68, 0x06, 0x91, 0x8a, 0x2d, 0x02}};
#define ICE_Task 0x3
EXTERN_C __declspec(selectany) const GUID ICEId = {0x255f5c19, 0xe0d4, 0x48bc, {0xa8, 0x80, 0x68, 0x06, 0x91, 0x8a, 0x2d, 0x03}};
#define webrtc_Task 0x4
EXTERN_C __declspec(selectany) const GUID webrtcId = {0x255f5c19, 0xe0d4, 0x48bc, {0xa8, 0x80, 0x68, 0x06, 0x91, 0x8a, 0x2d, 0x04}};

//
// Event Descriptors
//
EXTERN_C __declspec(selectany) const EVENT_DESCRIPTOR LongOp = {0x64, 0x0, 0x0, 0x0, 0xa, 0x1, 0x0};
#define LongOp_value 0x64
EXTERN_C __declspec(selectany) const EVENT_DESCRIPTOR UDPSendPacket = {0xc8, 0x0, 0x0, 0x0, 0xc, 0x2, 0x0};
#define UDPSendPacket_value 0xc8
EXTERN_C __declspec(selectany) const EVENT_DESCRIPTOR UDPRecvPacket = {0xc9, 0x0, 0x0, 0x0, 0xd, 0x2, 0x0};
#define UDPRecvPacket_value 0xc9
EXTERN_C __declspec(selectany) const EVENT_DESCRIPTOR ICESendPacket = {0x12c, 0x0, 0x0, 0x0, 0xb, 0x3, 0x0};
#define ICESendPacket_value 0x12c
EXTERN_C __declspec(selectany) const EVENT_DESCRIPTOR ICEProcessPacket = {0x12d, 0x0, 0x0, 0x0, 0xd, 0x3, 0x0};
#define ICEProcessPacket_value 0x12d
EXTERN_C __declspec(selectany) const EVENT_DESCRIPTOR ICERecvPacket = {0x12e, 0x0, 0x0, 0x0, 0xd, 0x3, 0x0};
#define ICERecvPacket_value 0x12e
EXTERN_C __declspec(selectany) const EVENT_DESCRIPTOR webrtc_send = {0x191, 0x0, 0x0, 0x0, 0xb, 0x4, 0x0};
#define webrtc_send_value 0x191
EXTERN_C __declspec(selectany) const EVENT_DESCRIPTOR webrtc_sendto = {0x192, 0x0, 0x0, 0x0, 0xc, 0x4, 0x0};
#define webrtc_sendto_value 0x192
EXTERN_C __declspec(selectany) const EVENT_DESCRIPTOR webrtc_setsockopt = {0x193, 0x0, 0x0, 0x0, 0xf, 0x4, 0x0};
#define webrtc_setsockopt_value 0x193

//
// Note on Generate Code from Manifest for Windows Vista and above
//
//Structures :  are handled as a size and pointer pairs. The macro for the event will have an extra 
//parameter for the size in bytes of the structure. Make sure that your structures have no extra padding.
//
//Strings: There are several cases that can be described in the manifest. For array of variable length 
//strings, the generated code will take the count of characters for the whole array as an input parameter. 
//
//SID No support for array of SIDs, the macro will take a pointer to the SID and use appropriate 
//GetLengthSid function to get the length.
//

//
// Allow disabling of code generation
//
#ifndef MCGEN_DISABLE_PROVIDER_CODE_GENERATION

//
// Globals 
//


//
// Event Enablement Bits
//

EXTERN_C __declspec(selectany) DECLSPEC_CACHEALIGN ULONG Valve_SteamNetworkingSocketsEnableBits[1];
EXTERN_C __declspec(selectany) const ULONGLONG Valve_SteamNetworkingSocketsKeywords[1] = {0x0};
EXTERN_C __declspec(selectany) const UCHAR Valve_SteamNetworkingSocketsLevels[1] = {0};
EXTERN_C __declspec(selectany) MCGEN_TRACE_CONTEXT VALVE_STEAMNETWORKINGSOCKETS_Context = {0, 0, 0, 0, 0, 0, 0, 0, 1, Valve_SteamNetworkingSocketsEnableBits, Valve_SteamNetworkingSocketsKeywords, Valve_SteamNetworkingSocketsLevels};

EXTERN_C __declspec(selectany) REGHANDLE Valve_SteamNetworkingSocketsHandle = (REGHANDLE)0;

#if !defined(McGenEventRegisterUnregister)
#define McGenEventRegisterUnregister
#pragma warning(push)
#pragma warning(disable:6103)
DECLSPEC_NOINLINE __inline
ULONG __stdcall
McGenEventRegister(
    _In_ LPCGUID ProviderId,
    _In_opt_ PENABLECALLBACK EnableCallback,
    _In_opt_ PVOID CallbackContext,
    _Inout_ PREGHANDLE RegHandle
    )
/*++

Routine Description:

    This function registers the provider with ETW USER mode.

Arguments:
    ProviderId - Provider ID to be register with ETW.

    EnableCallback - Callback to be used.

    CallbackContext - Context for this provider.

    RegHandle - Pointer to registration handle.

Remarks:

    If the handle != NULL will return ERROR_SUCCESS

--*/
{
    ULONG Error;


    if (*RegHandle) {
        //
        // already registered
        //
        return ERROR_SUCCESS;
    }

    Error = EventRegister( ProviderId, EnableCallback, CallbackContext, RegHandle); 

    return Error;
}
#pragma warning(pop)


DECLSPEC_NOINLINE __inline
ULONG __stdcall
McGenEventUnregister(_Inout_ PREGHANDLE RegHandle)
/*++

Routine Description:

    Unregister from ETW USER mode

Arguments:
            RegHandle this is the pointer to the provider context
Remarks:
            If provider has not been registered, RegHandle == NULL,
            return ERROR_SUCCESS
--*/
{
    ULONG Error;


    if(!(*RegHandle)) {
        //
        // Provider has not registerd
        //
        return ERROR_SUCCESS;
    }

    Error = EventUnregister(*RegHandle); 
    *RegHandle = (REGHANDLE)0;
    
    return Error;
}
#endif
//
// Register with ETW Vista +
//
#ifndef EventRegisterValve_SteamNetworkingSockets
#define EventRegisterValve_SteamNetworkingSockets() McGenEventRegister(&VALVE_STEAMNETWORKINGSOCKETS, McGenControlCallbackV2, &VALVE_STEAMNETWORKINGSOCKETS_Context, &Valve_SteamNetworkingSocketsHandle) 
#endif

//
// UnRegister with ETW
//
#ifndef EventUnregisterValve_SteamNetworkingSockets
#define EventUnregisterValve_SteamNetworkingSockets() McGenEventUnregister(&Valve_SteamNetworkingSocketsHandle) 
#endif

//
// Enablement check macro for LongOp
//

#define EventEnabledLongOp() ((Valve_SteamNetworkingSocketsEnableBits[0] & 0x00000001) != 0)

//
// Event Macro for LongOp
//
#define EventWriteLongOp(OpName, usec, Info)\
        EventEnabledLongOp() ?\
        Template_sis(Valve_SteamNetworkingSocketsHandle, &LongOp, OpName, usec, Info)\
        : ERROR_SUCCESS\

//
// Enablement check macro for UDPSendPacket
//

#define EventEnabledUDPSendPacket() ((Valve_SteamNetworkingSocketsEnableBits[0] & 0x00000001) != 0)

//
// Event Macro for UDPSendPacket
//
#define EventWriteUDPSendPacket(RemoteAddr, Size)\
        EventEnabledUDPSendPacket() ?\
        Template_sd(Valve_SteamNetworkingSocketsHandle, &UDPSendPacket, RemoteAddr, Size)\
        : ERROR_SUCCESS\

//
// Enablement check macro for UDPRecvPacket
//

#define EventEnabledUDPRecvPacket() ((Valve_SteamNetworkingSocketsEnableBits[0] & 0x00000001) != 0)

//
// Event Macro for UDPRecvPacket
//
#define EventWriteUDPRecvPacket(RemoteAddr, Size)\
        EventEnabledUDPRecvPacket() ?\
        Template_sd(Valve_SteamNetworkingSocketsHandle, &UDPRecvPacket, RemoteAddr, Size)\
        : ERROR_SUCCESS\

//
// Enablement check macro for ICESendPacket
//

#define EventEnabledICESendPacket() ((Valve_SteamNetworkingSocketsEnableBits[0] & 0x00000001) != 0)

//
// Event Macro for ICESendPacket
//
#define EventWriteICESendPacket(ConnectionID, Size)\
        EventEnabledICESendPacket() ?\
        Template_dd(Valve_SteamNetworkingSocketsHandle, &ICESendPacket, ConnectionID, Size)\
        : ERROR_SUCCESS\

//
// Enablement check macro for ICEProcessPacket
//

#define EventEnabledICEProcessPacket() ((Valve_SteamNetworkingSocketsEnableBits[0] & 0x00000001) != 0)

//
// Event Macro for ICEProcessPacket
//
#define EventWriteICEProcessPacket(ConnectionID, Size)\
        EventEnabledICEProcessPacket() ?\
        Template_dd(Valve_SteamNetworkingSocketsHandle, &ICEProcessPacket, ConnectionID, Size)\
        : ERROR_SUCCESS\

//
// Enablement check macro for ICERecvPacket
//

#define EventEnabledICERecvPacket() ((Valve_SteamNetworkingSocketsEnableBits[0] & 0x00000001) != 0)

//
// Event Macro for ICERecvPacket
//
#define EventWriteICERecvPacket(ConnectionID, Size)\
        EventEnabledICERecvPacket() ?\
        Template_dd(Valve_SteamNetworkingSocketsHandle, &ICERecvPacket, ConnectionID, Size)\
        : ERROR_SUCCESS\

//
// Enablement check macro for webrtc_send
//

#define EventEnabledwebrtc_send() ((Valve_SteamNetworkingSocketsEnableBits[0] & 0x00000001) != 0)

//
// Event Macro for webrtc_send
//
#define EventWritewebrtc_send(Size)\
        EventEnabledwebrtc_send() ?\
        Template_d(Valve_SteamNetworkingSocketsHandle, &webrtc_send, Size)\
        : ERROR_SUCCESS\

//
// Enablement check macro for webrtc_sendto
//

#define EventEnabledwebrtc_sendto() ((Valve_SteamNetworkingSocketsEnableBits[0] & 0x00000001) != 0)

//
// Event Macro for webrtc_sendto
//
#define EventWritewebrtc_sendto(RemoteAddr, Size)\
        EventEnabledwebrtc_sendto() ?\
        Template_sd(Valve_SteamNetworkingSocketsHandle, &webrtc_sendto, RemoteAddr, Size)\
        : ERROR_SUCCESS\

//
// Enablement check macro for webrtc_setsockopt
//

#define EventEnabledwebrtc_setsockopt() ((Valve_SteamNetworkingSocketsEnableBits[0] & 0x00000001) != 0)

//
// Event Macro for webrtc_setsockopt
//
#define EventWritewebrtc_setsockopt(level, opt, value)\
        EventEnabledwebrtc_setsockopt() ?\
        Template_ddd(Valve_SteamNetworkingSocketsHandle, &webrtc_setsockopt, level, opt, value)\
        : ERROR_SUCCESS\

#endif // MCGEN_DISABLE_PROVIDER_CODE_GENERATION


//
// Allow Diasabling of code generation
//
#ifndef MCGEN_DISABLE_PROVIDER_CODE_GENERATION

//
// Template Functions 
//
//
//Template from manifest : T_LongOp
//
#ifndef Template_sis_def
#define Template_sis_def
ETW_INLINE
ULONG
Template_sis(
    _In_ REGHANDLE RegHandle,
    _In_ PCEVENT_DESCRIPTOR Descriptor,
    _In_opt_ LPCSTR  _Arg0,
    _In_ signed __int64  _Arg1,
    _In_opt_ LPCSTR  _Arg2
    )
{
#define ARGUMENT_COUNT_sis 3

    EVENT_DATA_DESCRIPTOR EventData[ARGUMENT_COUNT_sis];

    EventDataDescCreate(&EventData[0], 
                        (_Arg0 != NULL) ? _Arg0 : "NULL",
                        (_Arg0 != NULL) ? (ULONG)((strlen(_Arg0) + 1) * sizeof(CHAR)) : (ULONG)sizeof("NULL"));

    EventDataDescCreate(&EventData[1], &_Arg1, sizeof(signed __int64)  );

    EventDataDescCreate(&EventData[2], 
                        (_Arg2 != NULL) ? _Arg2 : "NULL",
                        (_Arg2 != NULL) ? (ULONG)((strlen(_Arg2) + 1) * sizeof(CHAR)) : (ULONG)sizeof("NULL"));

    return EventWrite(RegHandle, Descriptor, ARGUMENT_COUNT_sis, EventData);
}
#endif

//
//Template from manifest : T_UDPPacket
//
#ifndef Template_sd_def
#define Template_sd_def
ETW_INLINE
ULONG
Template_sd(
    _In_ REGHANDLE RegHandle,
    _In_ PCEVENT_DESCRIPTOR Descriptor,
    _In_opt_ LPCSTR  _Arg0,
    _In_ const signed int  _Arg1
    )
{
#define ARGUMENT_COUNT_sd 2

    EVENT_DATA_DESCRIPTOR EventData[ARGUMENT_COUNT_sd];

    EventDataDescCreate(&EventData[0], 
                        (_Arg0 != NULL) ? _Arg0 : "NULL",
                        (_Arg0 != NULL) ? (ULONG)((strlen(_Arg0) + 1) * sizeof(CHAR)) : (ULONG)sizeof("NULL"));

    EventDataDescCreate(&EventData[1], &_Arg1, sizeof(const signed int)  );

    return EventWrite(RegHandle, Descriptor, ARGUMENT_COUNT_sd, EventData);
}
#endif

//
//Template from manifest : T_ICEPacket
//
#ifndef Template_dd_def
#define Template_dd_def
ETW_INLINE
ULONG
Template_dd(
    _In_ REGHANDLE RegHandle,
    _In_ PCEVENT_DESCRIPTOR Descriptor,
    _In_ const signed int  _Arg0,
    _In_ const signed int  _Arg1
    )
{
#define ARGUMENT_COUNT_dd 2

    EVENT_DATA_DESCRIPTOR EventData[ARGUMENT_COUNT_dd];

    EventDataDescCreate(&EventData[0], &_Arg0, sizeof(const signed int)  );

    EventDataDescCreate(&EventData[1], &_Arg1, sizeof(const signed int)  );

    return EventWrite(RegHandle, Descriptor, ARGUMENT_COUNT_dd, EventData);
}
#endif

//
//Template from manifest : T_webrtc_send
//
#ifndef Template_d_def
#define Template_d_def
ETW_INLINE
ULONG
Template_d(
    _In_ REGHANDLE RegHandle,
    _In_ PCEVENT_DESCRIPTOR Descriptor,
    _In_ const signed int  _Arg0
    )
{
#define ARGUMENT_COUNT_d 1

    EVENT_DATA_DESCRIPTOR EventData[ARGUMENT_COUNT_d];

    EventDataDescCreate(&EventData[0], &_Arg0, sizeof(const signed int)  );

    return EventWrite(RegHandle, Descriptor, ARGUMENT_COUNT_d, EventData);
}
#endif

//
//Template from manifest : T_webrtc_setsockopt
//
#ifndef Template_ddd_def
#define Template_ddd_def
ETW_INLINE
ULONG
Template_ddd(
    _In_ REGHANDLE RegHandle,
    _In_ PCEVENT_DESCRIPTOR Descriptor,
    _In_ const signed int  _Arg0,
    _In_ const signed int  _Arg1,
    _In_ const signed int  _Arg2
    )
{
#define ARGUMENT_COUNT_ddd 3

    EVENT_DATA_DESCRIPTOR EventData[ARGUMENT_COUNT_ddd];

    EventDataDescCreate(&EventData[0], &_Arg0, sizeof(const signed int)  );

    EventDataDescCreate(&EventData[1], &_Arg1, sizeof(const signed int)  );

    EventDataDescCreate(&EventData[2], &_Arg2, sizeof(const signed int)  );

    return EventWrite(RegHandle, Descriptor, ARGUMENT_COUNT_ddd, EventData);
}
#endif

#endif // MCGEN_DISABLE_PROVIDER_CODE_GENERATION

#if defined(__cplusplus)
};
#endif

